diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-phy.cc ns-3.34/src/wifi/model/wifi-phy.cc
--- ns-3.33/src/wifi/model/wifi-phy.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-phy.cc	2021-07-14 10:31:07.000000000 -0700
@@ -4266,267 +1974,121 @@
   return false;
 }
 
-bool
-WifiPhy::IsMcsSupported (WifiMode mcs) const
+WifiMode
+WifiPhy::GetDefaultMode (void) const
 {
-  WifiModulationClass modulation = mcs.GetModulationClass ();
-  if (modulation == WIFI_MOD_CLASS_HT || modulation == WIFI_MOD_CLASS_VHT
-      || modulation == WIFI_MOD_CLASS_HE)
+  //Start from oldest standards and move up (guaranteed by fact that WifModulationClass is ordered)
+  for (const auto & phyEntity : m_phyEntities)
     {
-      return IsMcsSupported (modulation, mcs.GetMcsValue ());
+      for (const auto & mode : *(phyEntity.second))
+        {
+          return mode;
+        }
     }
-  return false;
+  NS_ASSERT_MSG (false, "Should have found at least one default mode");
+  return WifiMode ();
 }
 
 bool
-WifiPhy::IsMcsSupported (WifiModulationClass mc, uint8_t mcs) const
+WifiPhy::IsMcsSupported (WifiModulationClass modulation, uint8_t mcs) const
 {
-  if (m_mcsIndexMap.find (mc) == m_mcsIndexMap.end ())
-    {
-      return false;
-    }
-  if (m_mcsIndexMap.at (mc).find (mcs) == m_mcsIndexMap.at (mc).end ())
+  const auto phyEntity = m_phyEntities.find (modulation);
+  if (phyEntity == m_phyEntities.end ())
     {
       return false;
     }
-  return true;
+  return phyEntity->second->IsMcsSupported (mcs);
 }
 
-uint8_t
-WifiPhy::GetNModes (void) const
+std::list<WifiMode>
+WifiPhy::GetModeList (void) const
 {
-  return static_cast<uint8_t> (m_deviceRateSet.size ());
+  std::list<WifiMode> list;
+  for (const auto & phyEntity : m_phyEntities)
+    {
+      if (!phyEntity.second->HandlesMcsModes ()) //to exclude MCSs from search
+        {
+          for (const auto & mode : *(phyEntity.second))
+            {
+              list.emplace_back (mode);
+            }
+        }
+    }
+  return list;
 }
 
-WifiMode
-WifiPhy::GetMode (uint8_t mode) const
+std::list<WifiMode>
+WifiPhy::GetModeList (WifiModulationClass modulation) const
 {
-  return m_deviceRateSet[mode];
+  std::list<WifiMode> list;
+  const auto phyEntity = m_phyEntities.find (modulation);
+  if (phyEntity != m_phyEntities.end ())
+    {
+      if (!phyEntity->second->HandlesMcsModes ()) //to exclude MCSs from search
+        {
+          for (const auto & mode : *(phyEntity->second))
+            {
+              list.emplace_back (mode);
+            }
+        }
+    }
+  return list;
 }
 
-uint8_t
+uint16_t
 WifiPhy::GetNMcs (void) const
 {
-  return static_cast<uint8_t> (m_deviceMcsSet.size ());
-}
-
-WifiMode
-WifiPhy::GetMcs (uint8_t mcs) const
-{
-  return m_deviceMcsSet[mcs];
-}
-
-WifiMode
-WifiPhy::GetMcs (WifiModulationClass modulation, uint8_t mcs) const
-{
-  NS_ASSERT_MSG (IsMcsSupported (modulation, mcs), "Unsupported MCS");
-  uint8_t index = m_mcsIndexMap.at (modulation).at (mcs);
-  NS_ASSERT (index < m_deviceMcsSet.size ());
-  WifiMode mode = m_deviceMcsSet[index];
-  NS_ASSERT (mode.GetModulationClass () == modulation);
-  NS_ASSERT (mode.GetMcsValue () == mcs);
-  return mode;
+  uint16_t numMcs = 0;
+  for (const auto & phyEntity : m_phyEntities)
+    {
+      if (phyEntity.second->HandlesMcsModes ()) //to exclude non-MCS modes from search
+        {
+          numMcs += phyEntity.second->GetNumModes ();
+        }
+    }
+  return numMcs;
 }
 
-WifiMode
-WifiPhy::GetHtMcs (uint8_t mcs)
+std::list<WifiMode>
+WifiPhy::GetMcsList (void) const
 {
-  WifiMode mode;
-  switch (mcs)
+  std::list<WifiMode> list;
+  for (const auto & phyEntity : m_phyEntities)
     {
-      case 0:
-        mode = WifiPhy::GetHtMcs0 ();
-        break;
-      case 1:
-        mode = WifiPhy::GetHtMcs1 ();
-        break;
-      case 2:
-        mode = WifiPhy::GetHtMcs2 ();
-        break;
-      case 3:
-        mode = WifiPhy::GetHtMcs3 ();
-        break;
-      case 4:
-        mode = WifiPhy::GetHtMcs4 ();
-        break;
-      case 5:
-        mode = WifiPhy::GetHtMcs5 ();
-        break;
-      case 6:
-        mode = WifiPhy::GetHtMcs6 ();
-        break;
-      case 7:
-        mode = WifiPhy::GetHtMcs7 ();
-        break;
-      case 8:
-        mode = WifiPhy::GetHtMcs8 ();
-        break;
-      case 9:
-        mode = WifiPhy::GetHtMcs9 ();
-        break;
-      case 10:
-        mode = WifiPhy::GetHtMcs10 ();
-        break;
-      case 11:
-        mode = WifiPhy::GetHtMcs11 ();
-        break;
-      case 12:
-        mode = WifiPhy::GetHtMcs12 ();
-        break;
-      case 13:
-        mode = WifiPhy::GetHtMcs13 ();
-        break;
-      case 14:
-        mode = WifiPhy::GetHtMcs14 ();
-        break;
-      case 15:
-        mode = WifiPhy::GetHtMcs15 ();
-        break;
-      case 16:
-        mode = WifiPhy::GetHtMcs16 ();
-        break;
-      case 17:
-        mode = WifiPhy::GetHtMcs17 ();
-        break;
-      case 18:
-        mode = WifiPhy::GetHtMcs18 ();
-        break;
-      case 19:
-        mode = WifiPhy::GetHtMcs19 ();
-        break;
-      case 20:
-        mode = WifiPhy::GetHtMcs20 ();
-        break;
-      case 21:
-        mode = WifiPhy::GetHtMcs21 ();
-        break;
-      case 22:
-        mode = WifiPhy::GetHtMcs22 ();
-        break;
-      case 23:
-        mode = WifiPhy::GetHtMcs23 ();
-        break;
-      case 24:
-        mode = WifiPhy::GetHtMcs24 ();
-        break;
-      case 25:
-        mode = WifiPhy::GetHtMcs25 ();
-        break;
-      case 26:
-        mode = WifiPhy::GetHtMcs26 ();
-        break;
-      case 27:
-        mode = WifiPhy::GetHtMcs27 ();
-        break;
-      case 28:
-        mode = WifiPhy::GetHtMcs28 ();
-        break;
-      case 29:
-        mode = WifiPhy::GetHtMcs29 ();
-        break;
-      case 30:
-        mode = WifiPhy::GetHtMcs30 ();
-        break;
-      case 31:
-        mode = WifiPhy::GetHtMcs31 ();
-        break;
-      default:
-        NS_ABORT_MSG ("Invalid HT MCS");
-        break;
+      if (phyEntity.second->HandlesMcsModes ()) //to exclude non-MCS modes from search
+        {
+          for (const auto & mode : *(phyEntity.second))
+            {
+              list.emplace_back (mode);
+            }
+        }
     }
-  return mode;
+  return list;
 }
 
-WifiMode
-WifiPhy::GetVhtMcs (uint8_t mcs)
+std::list<WifiMode>
+WifiPhy::GetMcsList (WifiModulationClass modulation) const
 {
-  WifiMode mode;
-  switch (mcs)
+  std::list<WifiMode> list;
+  auto phyEntity = m_phyEntities.find (modulation);
+  if (phyEntity != m_phyEntities.end ())
     {
-      case 0:
-        mode = WifiPhy::GetVhtMcs0 ();
-        break;
-      case 1:
-        mode = WifiPhy::GetVhtMcs1 ();
-        break;
-      case 2:
-        mode = WifiPhy::GetVhtMcs2 ();
-        break;
-      case 3:
-        mode = WifiPhy::GetVhtMcs3 ();
-        break;
-      case 4:
-        mode = WifiPhy::GetVhtMcs4 ();
-        break;
-      case 5:
-        mode = WifiPhy::GetVhtMcs5 ();
-        break;
-      case 6:
-        mode = WifiPhy::GetVhtMcs6 ();
-        break;
-      case 7:
-        mode = WifiPhy::GetVhtMcs7 ();
-        break;
-      case 8:
-        mode = WifiPhy::GetVhtMcs8 ();
-        break;
-      case 9:
-        mode = WifiPhy::GetVhtMcs9 ();
-        break;
-      default:
-        NS_ABORT_MSG ("Invalid VHT MCS");
-        break;
+      if (phyEntity->second->HandlesMcsModes ()) //to exclude non-MCS modes from search
+        {
+          for (const auto & mode : *(phyEntity->second))
+            {
+              list.emplace_back (mode);
+            }
+        }
     }
-  return mode;
+  return list;
 }
 
 WifiMode
-WifiPhy::GetHeMcs (uint8_t mcs)
+WifiPhy::GetMcs (WifiModulationClass modulation, uint8_t mcs) const
 {
-  WifiMode mode;
-  switch (mcs)
-    {
-      case 0:
-        mode = WifiPhy::GetHeMcs0 ();
-        break;
-      case 1:
-        mode = WifiPhy::GetHeMcs1 ();
-        break;
-      case 2:
-        mode = WifiPhy::GetHeMcs2 ();
-        break;
-      case 3:
-        mode = WifiPhy::GetHeMcs3 ();
-        break;
-      case 4:
-        mode = WifiPhy::GetHeMcs4 ();
-        break;
-      case 5:
-        mode = WifiPhy::GetHeMcs5 ();
-        break;
-      case 6:
-        mode = WifiPhy::GetHeMcs6 ();
-        break;
-      case 7:
-        mode = WifiPhy::GetHeMcs7 ();
-        break;
-      case 8:
-        mode = WifiPhy::GetHeMcs8 ();
-        break;
-      case 9:
-        mode = WifiPhy::GetHeMcs9 ();
-        break;
-      case 10:
-        mode = WifiPhy::GetHeMcs10 ();
-        break;
-      case 11:
-        mode = WifiPhy::GetHeMcs11 ();
-        break;
-      default:
-        NS_ABORT_MSG ("Invalid HE MCS");
-        break;
-    }
-  return mode;
+  NS_ASSERT_MSG (IsMcsSupported (modulation, mcs), "Unsupported MCS");
+  return m_phyEntities.at (modulation)->GetMcs (mcs);
 }
 
 bool
@@ -4590,16 +2152,14 @@
 }
 
 void
-WifiPhy::SwitchMaybeToCcaBusy (void)
+WifiPhy::SwitchMaybeToCcaBusy (uint16_t channelWidth)
 {
-  NS_LOG_FUNCTION (this);
+  NS_LOG_FUNCTION (this << channelWidth);
   //We are here because we have received the first bit of a packet and we are
   //not going to be able to synchronize on it
   //In this model, CCA becomes busy when the aggregation of all signals as
   //tracked by the InterferenceHelper class is higher than the CcaBusyThreshold
-
-  uint16_t primaryChannelWidth = GetChannelWidth () >= 40 ? 20 : GetChannelWidth ();
-  Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW, GetBand (primaryChannelWidth));
+  Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW, GetPrimaryBand (channelWidth));
   if (!delayUntilCcaEnd.IsZero ())
     {
       NS_LOG_DEBUG ("Calling SwitchMaybeToCcaBusy for " << delayUntilCcaEnd.As (Time::S));
@@ -4611,138 +2171,107 @@
 WifiPhy::AbortCurrentReception (WifiPhyRxfailureReason reason)
 {
   NS_LOG_FUNCTION (this << reason);
-  if (m_endPreambleDetectionEvent.IsRunning ())
-    {
-      m_endPreambleDetectionEvent.Cancel ();
-    }
-  if (m_endPhyRxEvent.IsRunning ())
+  if (reason != OBSS_PD_CCA_RESET || m_currentEvent) //Otherwise abort has already been called previously
     {
-      m_endPhyRxEvent.Cancel ();
-    }
-  if (m_endRxEvent.IsRunning ())
-    {
-      m_endRxEvent.Cancel ();
-    }
-  NotifyRxDrop (GetAddressedPsduInPpdu (m_currentEvent->GetPpdu ()), reason);
-  m_interference.NotifyRxEnd ();
-  if (reason == OBSS_PD_CCA_RESET)
-    {
-      m_state->SwitchFromRxAbort ();
+      for (auto & phyEntity : m_phyEntities)
+        {
+          phyEntity.second->CancelAllEvents ();
+        }
+      if (m_endPhyRxEvent.IsRunning ())
+        {
+          m_endPhyRxEvent.Cancel ();
+        }
+      m_interference.NotifyRxEnd (Simulator::Now ());
+      if (!m_currentEvent)
+        {
+          return;
+        }
+      NotifyRxDrop (GetAddressedPsduInPpdu (m_currentEvent->GetPpdu ()), reason);
+      if (reason == OBSS_PD_CCA_RESET)
+        {
+          m_state->SwitchFromRxAbort ();
+        }
+      for (auto it = m_currentPreambleEvents.begin (); it != m_currentPreambleEvents.end (); ++it)
+        {
+          if (it->second == m_currentEvent)
+            {
+              it = m_currentPreambleEvents.erase (it);
+              break;
+            }
+        }
+      m_currentEvent = 0;
     }
-  m_currentEvent = 0;
 }
 
 void
 WifiPhy::ResetCca (bool powerRestricted, double txPowerMaxSiso, double txPowerMaxMimo)
 {
   NS_LOG_FUNCTION (this << powerRestricted << txPowerMaxSiso << txPowerMaxMimo);
-  m_powerRestricted = powerRestricted;
-  m_txPowerMaxSiso = txPowerMaxSiso;
-  m_txPowerMaxMimo = txPowerMaxMimo;
-  NS_ASSERT ((m_currentEvent->GetEndTime () - Simulator::Now ()).IsPositive ());
-  Simulator::Schedule (m_currentEvent->GetEndTime () - Simulator::Now (), &WifiPhy::EndReceiveInterBss, this);
-  AbortCurrentReception (OBSS_PD_CCA_RESET);
+  // This method might be called multiple times when receiving TB PPDUs with a BSS color
+  // different than the one of the receiver. The first time this method is called, the call
+  // to AbortCurrentReception sets m_currentEvent to 0. Therefore, we need to check whether
+  // m_currentEvent is not 0 before executing the instructions below.
+  if (m_currentEvent != 0)
+    {
+      m_powerRestricted = powerRestricted;
+      m_txPowerMaxSiso = txPowerMaxSiso;
+      m_txPowerMaxMimo = txPowerMaxMimo;
+      NS_ASSERT ((m_currentEvent->GetEndTime () - Simulator::Now ()).IsPositive ());
+      Simulator::Schedule (m_currentEvent->GetEndTime () - Simulator::Now (), &WifiPhy::EndReceiveInterBss, this);
+      Simulator::ScheduleNow (&WifiPhy::AbortCurrentReception, this, OBSS_PD_CCA_RESET); //finish processing field first
+    }
 }
 
 double
-WifiPhy::GetTxPowerForTransmission (WifiTxVector txVector) const
+WifiPhy::GetTxPowerForTransmission (Ptr<const WifiPpdu> ppdu) const
 {
-  NS_LOG_FUNCTION (this << m_powerRestricted);
+  NS_LOG_FUNCTION (this << m_powerRestricted << ppdu);
+  const WifiTxVector& txVector = ppdu->GetTxVector ();
+  // Get transmit power before antenna gain
+  double txPowerDbm;
   if (!m_powerRestricted)
     {
-      return GetPowerDbm (txVector.GetTxPowerLevel ());
+      txPowerDbm = GetPowerDbm (txVector.GetTxPowerLevel ());
     }
   else
     {
       if (txVector.GetNssMax () > 1)
         {
-          return std::min (m_txPowerMaxMimo, GetPowerDbm (txVector.GetTxPowerLevel ()));
+          txPowerDbm = std::min (m_txPowerMaxMimo, GetPowerDbm (txVector.GetTxPowerLevel ()));
         }
       else
         {
-          return std::min (m_txPowerMaxSiso, GetPowerDbm (txVector.GetTxPowerLevel ()));
+          txPowerDbm = std::min (m_txPowerMaxSiso, GetPowerDbm (txVector.GetTxPowerLevel ()));
         }
     }
-}
 
-void
-WifiPhy::StartRx (Ptr<Event> event)
-{
-  uint16_t primaryChannelWidth = GetChannelWidth () >= 40 ? 20 : GetChannelWidth ();
-  auto primaryBand = GetBand (primaryChannelWidth);
-  double rxPowerW = event->GetRxPowerW (primaryBand);
-  NS_LOG_FUNCTION (this << *event << rxPowerW);
-
-  NS_LOG_DEBUG ("sync to signal (power=" << rxPowerW << "W)");
-  m_interference.NotifyRxStart (); //We need to notify it now so that it starts recording events
-
-  if (!m_endPreambleDetectionEvent.IsRunning ())
-    {
-      Time startOfPreambleDuration = GetPreambleDetectionDuration ();
-      Time remainingRxDuration = event->GetDuration () - startOfPreambleDuration;
-      m_endPreambleDetectionEvent = Simulator::Schedule (startOfPreambleDuration, &WifiPhy::StartReceiveHeader, this, event);
-    }
-  else if ((m_frameCaptureModel != 0) && (rxPowerW > m_currentEvent->GetRxPowerW (primaryBand)))
-    {
-      NS_LOG_DEBUG ("Received a stronger signal during preamble detection: drop current packet and switch to new packet");
-      NotifyRxDrop (GetAddressedPsduInPpdu (m_currentEvent->GetPpdu ()), PREAMBLE_DETECTION_PACKET_SWITCH);
-      m_interference.NotifyRxEnd ();
-      m_endPreambleDetectionEvent.Cancel ();
-      m_interference.NotifyRxStart ();
-      Time startOfPreambleDuration = GetPreambleDetectionDuration ();
-      Time remainingRxDuration = event->GetDuration () - startOfPreambleDuration;
-      m_endPreambleDetectionEvent = Simulator::Schedule (startOfPreambleDuration, &WifiPhy::StartReceiveHeader, this, event);
-    }
-  else
-    {
-      NS_LOG_DEBUG ("Drop packet because RX is already decoding preamble");
-      NotifyRxDrop (GetAddressedPsduInPpdu (event->GetPpdu ()), BUSY_DECODING_PREAMBLE);
-      return;
-    }
-  m_currentEvent = event;
+  //Apply power density constraint on EIRP
+  uint16_t channelWidth = ppdu->GetTransmissionChannelWidth ();
+  double txPowerDbmPerMhz = (txPowerDbm + GetTxGain ()) - RatioToDb (channelWidth); //account for antenna gain since EIRP
+  NS_LOG_INFO ("txPowerDbm=" << txPowerDbm << " with txPowerDbmPerMhz=" << txPowerDbmPerMhz << " over " << channelWidth << " MHz");
+  txPowerDbm = std::min (txPowerDbmPerMhz, m_powerDensityLimit) + RatioToDb (channelWidth);
+  txPowerDbm -= GetTxGain (); //remove antenna gain since will be added right afterwards
+  NS_LOG_INFO ("txPowerDbm=" << txPowerDbm << " after applying m_powerDensityLimit=" << m_powerDensityLimit);
+  return txPowerDbm;
 }
 
 Ptr<const WifiPsdu>
 WifiPhy::GetAddressedPsduInPpdu (Ptr<const WifiPpdu> ppdu) const
 {
-  Ptr<const WifiPsdu> psdu;
-  if (!ppdu->IsMu ())
-    {
-      psdu = ppdu->GetPsdu ();
-    }
-  else
-    {
-      uint8_t bssColor = 0;
-      Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (GetDevice ());
-      if (device)
-        {
-          Ptr<HeConfiguration> heConfiguration = device->GetHeConfiguration ();
-          if (heConfiguration)
-            {
-              UintegerValue bssColorAttribute;
-              heConfiguration->GetAttribute ("BssColor", bssColorAttribute);
-              bssColor = bssColorAttribute.Get ();
-            }
-        }
-      uint16_t staId = GetStaId ();
-      psdu = ppdu->GetPsdu (bssColor, staId);
-    }
-    return psdu;
+  //TODO: wrapper. See if still needed
+  return GetPhyEntity (ppdu->GetModulation ())->GetAddressedPsduInPpdu (ppdu);
 }
 
 uint16_t
-WifiPhy::GetStaId (void) const
+WifiPhy::GetMeasurementChannelWidth (const Ptr<const WifiPpdu> ppdu) const
 {
-  Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (GetDevice ());
-  if (device)
+  if (ppdu == nullptr)
     {
-      Ptr<StaWifiMac> mac = DynamicCast<StaWifiMac> (device->GetMac ());
-      if (mac && mac->IsAssociated ())
-        {
-          return mac->GetAssociationId ();
-        }
+      // Here because PHY was not receiving anything (e.g. resuming from OFF) nor expecting anything (e.g. sleep)
+      // nor processing a Wi-Fi signal.
+      return GetChannelWidth () >= 40 ? 20 : GetChannelWidth ();
     }
-  return SU_STA_ID;
+  return GetPhyEntity (ppdu->GetModulation ())->GetMeasurementChannelWidth (ppdu);
 }
 
 WifiSpectrumBand
@@ -4754,117 +2283,32 @@
   return band;
 }
 
+WifiSpectrumBand
+WifiPhy::GetPrimaryBand (uint16_t bandWidth)
+{
+  if (GetChannelWidth () % 20 != 0)
+    {
+      return GetBand (bandWidth);
+    }
+
+  return GetBand (bandWidth, m_operatingChannel.GetPrimaryChannelIndex (bandWidth));
+}
+
 int64_t
 WifiPhy::AssignStreams (int64_t stream)
 {
   NS_LOG_FUNCTION (this << stream);
-  m_random->SetStream (stream);
-  return 1;
+  int64_t currentStream = stream;
+  m_random->SetStream (currentStream++);
+  currentStream += m_interference.GetErrorRateModel ()->AssignStreams (currentStream);
+  return (currentStream - stream);
 }
 
-} //namespace ns3
-
-namespace {
-
-/**
- * Constructor class
- */
-static class Constructor
-{
-public:
-  Constructor ()
-  {
-    ns3::WifiPhy::GetDsssRate1Mbps ();
-    ns3::WifiPhy::GetDsssRate2Mbps ();
-    ns3::WifiPhy::GetDsssRate5_5Mbps ();
-    ns3::WifiPhy::GetDsssRate11Mbps ();
-    ns3::WifiPhy::GetErpOfdmRate6Mbps ();
-    ns3::WifiPhy::GetErpOfdmRate9Mbps ();
-    ns3::WifiPhy::GetErpOfdmRate12Mbps ();
-    ns3::WifiPhy::GetErpOfdmRate18Mbps ();
-    ns3::WifiPhy::GetErpOfdmRate24Mbps ();
-    ns3::WifiPhy::GetErpOfdmRate36Mbps ();
-    ns3::WifiPhy::GetErpOfdmRate48Mbps ();
-    ns3::WifiPhy::GetErpOfdmRate54Mbps ();
-    ns3::WifiPhy::GetOfdmRate6Mbps ();
-    ns3::WifiPhy::GetOfdmRate9Mbps ();
-    ns3::WifiPhy::GetOfdmRate12Mbps ();
-    ns3::WifiPhy::GetOfdmRate18Mbps ();
-    ns3::WifiPhy::GetOfdmRate24Mbps ();
-    ns3::WifiPhy::GetOfdmRate36Mbps ();
-    ns3::WifiPhy::GetOfdmRate48Mbps ();
-    ns3::WifiPhy::GetOfdmRate54Mbps ();
-    ns3::WifiPhy::GetOfdmRate3MbpsBW10MHz ();
-    ns3::WifiPhy::GetOfdmRate4_5MbpsBW10MHz ();
-    ns3::WifiPhy::GetOfdmRate6MbpsBW10MHz ();
-    ns3::WifiPhy::GetOfdmRate9MbpsBW10MHz ();
-    ns3::WifiPhy::GetOfdmRate12MbpsBW10MHz ();
-    ns3::WifiPhy::GetOfdmRate18MbpsBW10MHz ();
-    ns3::WifiPhy::GetOfdmRate24MbpsBW10MHz ();
-    ns3::WifiPhy::GetOfdmRate27MbpsBW10MHz ();
-    ns3::WifiPhy::GetOfdmRate1_5MbpsBW5MHz ();
-    ns3::WifiPhy::GetOfdmRate2_25MbpsBW5MHz ();
-    ns3::WifiPhy::GetOfdmRate3MbpsBW5MHz ();
-    ns3::WifiPhy::GetOfdmRate4_5MbpsBW5MHz ();
-    ns3::WifiPhy::GetOfdmRate6MbpsBW5MHz ();
-    ns3::WifiPhy::GetOfdmRate9MbpsBW5MHz ();
-    ns3::WifiPhy::GetOfdmRate12MbpsBW5MHz ();
-    ns3::WifiPhy::GetOfdmRate13_5MbpsBW5MHz ();
-    ns3::WifiPhy::GetHtMcs0 ();
-    ns3::WifiPhy::GetHtMcs1 ();
-    ns3::WifiPhy::GetHtMcs2 ();
-    ns3::WifiPhy::GetHtMcs3 ();
-    ns3::WifiPhy::GetHtMcs4 ();
-    ns3::WifiPhy::GetHtMcs5 ();
-    ns3::WifiPhy::GetHtMcs6 ();
-    ns3::WifiPhy::GetHtMcs7 ();
-    ns3::WifiPhy::GetHtMcs8 ();
-    ns3::WifiPhy::GetHtMcs9 ();
-    ns3::WifiPhy::GetHtMcs10 ();
-    ns3::WifiPhy::GetHtMcs11 ();
-    ns3::WifiPhy::GetHtMcs12 ();
-    ns3::WifiPhy::GetHtMcs13 ();
-    ns3::WifiPhy::GetHtMcs14 ();
-    ns3::WifiPhy::GetHtMcs15 ();
-    ns3::WifiPhy::GetHtMcs16 ();
-    ns3::WifiPhy::GetHtMcs17 ();
-    ns3::WifiPhy::GetHtMcs18 ();
-    ns3::WifiPhy::GetHtMcs19 ();
-    ns3::WifiPhy::GetHtMcs20 ();
-    ns3::WifiPhy::GetHtMcs21 ();
-    ns3::WifiPhy::GetHtMcs22 ();
-    ns3::WifiPhy::GetHtMcs23 ();
-    ns3::WifiPhy::GetHtMcs24 ();
-    ns3::WifiPhy::GetHtMcs25 ();
-    ns3::WifiPhy::GetHtMcs26 ();
-    ns3::WifiPhy::GetHtMcs27 ();
-    ns3::WifiPhy::GetHtMcs28 ();
-    ns3::WifiPhy::GetHtMcs29 ();
-    ns3::WifiPhy::GetHtMcs30 ();
-    ns3::WifiPhy::GetHtMcs31 ();
-    ns3::WifiPhy::GetVhtMcs0 ();
-    ns3::WifiPhy::GetVhtMcs1 ();
-    ns3::WifiPhy::GetVhtMcs2 ();
-    ns3::WifiPhy::GetVhtMcs3 ();
-    ns3::WifiPhy::GetVhtMcs4 ();
-    ns3::WifiPhy::GetVhtMcs5 ();
-    ns3::WifiPhy::GetVhtMcs6 ();
-    ns3::WifiPhy::GetVhtMcs7 ();
-    ns3::WifiPhy::GetVhtMcs8 ();
-    ns3::WifiPhy::GetVhtMcs9 ();
-    ns3::WifiPhy::GetHeMcs0 ();
-    ns3::WifiPhy::GetHeMcs1 ();
-    ns3::WifiPhy::GetHeMcs2 ();
-    ns3::WifiPhy::GetHeMcs3 ();
-    ns3::WifiPhy::GetHeMcs4 ();
-    ns3::WifiPhy::GetHeMcs5 ();
-    ns3::WifiPhy::GetHeMcs6 ();
-    ns3::WifiPhy::GetHeMcs7 ();
-    ns3::WifiPhy::GetHeMcs8 ();
-    ns3::WifiPhy::GetHeMcs9 ();
-    ns3::WifiPhy::GetHeMcs10 ();
-    ns3::WifiPhy::GetHeMcs11 ();
-  }
-} g_constructor; ///< the constructor
-
+std::ostream& operator<< (std::ostream& os, RxSignalInfo rxSignalInfo)
+{
+  os << "SNR:" << RatioToDb (rxSignalInfo.snr) << " dB"
+     << ", RSSI:" << rxSignalInfo.rssi << " dBm";
+  return os;
 }
+
+} //namespace ns3
